import pandas as pd
import numpy as np


data = pd.read_csv('db_dump.csv',delimiter=';')#Lese die Csv als Panda Dataframe ein
relevantData= pd.DataFrame.copy(data[['Streckenvorhersage.ZielortID','Streckenvorhersage.StartortID','Streckenvorhersage.Dauer']]) # filtere die relevaten Daten
helpSeries= pd.DataFrame(np.zeros(relevantData.shape[0])) # eine Spalte mit nullen für weitere ergänzten Spalten
#Spalten ergänzen für Zeit, einen Index für den Tag und den einzelnen Wochentagen
relevantData['time']=helpSeries      
relevantData['day_index']=helpSeries
relevantData['weekday']=helpSeries

dates= data['Streckenvorhersage.Datum'] # fürs bessere Arbeiten alle Datum-Einträge in ein Hilfs-Dataframe einlesen
for d in range(dates.shape[0]):
    toTest =  dates[d]  #Aufteilen des Datums in die Bestandteile + zusammenrechnen der gesamt sekunden
    hours = toTest[11:13]
    minutes = toTest[14:16]
    seconds = int(toTest[17:19]) + int(hours)*60*60 + int(minutes)*60
    day = toTest[0:2]
    month = toTest[3:5]
    year = toTest[6:10]
    day_index= int(day)+int(month)*31+int(year)*49
    #relevantData.at[d,'month']= month
    #relevantData.at[d,'day']=day
    #relevantData.at[d,'year']=year
    relevantData.at[d,'time']=seconds
    relevantData.at[d,'day_index']=day_index
    relevantData.at[d,'weekday']=pd.to_datetime(year+'-'+month+'-'+day)
    relevantData.at[d,'weekday']=relevantData.loc[d,'weekday'].dayofweek

relevantData.to_csv('data.csv')  # neue csv mit lediglich relevanten daten errstellen
