from sklearn.model_selection import train_test_split
import numpy as np
import pandas as pd
from sklearn.ensemble import RandomForestRegressor
from sklearn.metrics import mean_absolute_percentage_error
from sklearn.model_selection import GridSearchCV

dataset = np.genfromtxt('Random Forest/data.csv', delimiter=',', skip_header=1)
x = dataset[:,np.arange(2,26)]
y = dataset[:,0]

x_train, x_test, y_train, y_test = train_test_split(x, y, test_size=0.25, random_state=42)

param_grid = {
    #'bootstrap': [True, False],
    'max_depth': [25,50,75,100, None],
    #'max_features': ["auto", "sqrt", "log2"],
    #'min_samples_leaf': [1,3,5],
    #'min_samples_split': [2,4,6],
    'n_estimators': [1000],
    'random_state': [42]
}

rf = RandomForestRegressor()

grid_search = GridSearchCV(estimator = rf, param_grid = param_grid, cv = 3, n_jobs = -1, verbose = 2)
grid_search.fit(x_train, y_train)

print(grid_search.best_params_)

y_predict = grid_search.best_estimator_.predict(x_test)
accuracy = (1-mean_absolute_percentage_error(y_test, y_predict))*100
print("Accuracy: " + str(accuracy) + '%')


