import pandas as pd

df = pd.read_csv("Random Forest/db_dump.csv", delimiter=';', usecols=[
                 'Streckenvorhersage.Dauer', 'Streckenvorhersage.Entfernung', 'Streckenvorhersage.ZielortID', 'Streckenvorhersage.Datum'])

df = df.reindex(columns=['Streckenvorhersage.Dauer', 'Streckenvorhersage.Entfernung',
                         'Streckenvorhersage.ZielortID', 'Streckenvorhersage.Datum'])

df['Streckenvorhersage.Year'] = [pd.Timestamp(
    d).year for d in df['Streckenvorhersage.Datum']]
df['Streckenvorhersage.Month'] = [pd.Timestamp(
    d).month for d in df['Streckenvorhersage.Datum']]
df['Streckenvorhersage.Day'] = [pd.Timestamp(
    d).day for d in df['Streckenvorhersage.Datum']]
df['Streckenvorhersage.DayOfWeek'] = [pd.Timestamp(
    d).day_of_week for d in df['Streckenvorhersage.Datum']]
df['Streckenvorhersage.Hour'] = [pd.Timestamp(
    d).hour for d in df['Streckenvorhersage.Datum']]
df['Streckenvorhersage.Minutes'] = [pd.Timestamp(
    d).minute for d in df['Streckenvorhersage.Datum']]

df.drop(['Streckenvorhersage.Datum'], axis=1, inplace=True)

# One-Hot Encoding
df = pd.concat(
    [df, pd.get_dummies(df['Streckenvorhersage.DayOfWeek'], prefix='DayOfWeek')], axis=1)
df.drop(['Streckenvorhersage.DayOfWeek'], axis=1, inplace=True)

# One-Hot Encoding ZielortID
df = pd.concat(
    [df, pd.get_dummies(df['Streckenvorhersage.ZielortID'], prefix='ZielortID')], axis=1)
df.drop(['Streckenvorhersage.ZielortID'], axis=1, inplace=True)

df.to_csv("Random Forest/data.csv", index=False)
