import tkinter as tk
import pickle
import numpy as np
from datetime import datetime,date

# liste aller möglichen Orte
OptionList = [
"Hochschule Bochum",
"Centro Oberhausen",
"Unperfekthaus Essen",
"Neanderthalmuseum",
"Kö-Bogen",
"Haus Kemnade",
"ZOOM Erlebniswelt",
"Villa Hügel",
"Wallfahrt Neviges",
"Ruhr Park",
"Schloss Burg",
"Haus Ruhrnatur"
] 

app = tk.Tk()

app.geometry('1000x300') #Pop-up in der Größe 1000x300

variable = tk.StringVar(app) # erstelle eine Variable die ausgelesen werden kann und auf die Orts-Liste zeigt
variable.set(OptionList[0]) # initialwert dieser Variable ist das erste Objekt
lsum = tk.Label(app, text = 'Wohin möchten Sie?',font = ('Helvetica', 26))#Start Label
lsum.pack()
opt = tk.OptionMenu(app, variable, *OptionList)#Drop-Down Menü
opt.config(width=90, font=('Helvetica', 32))
opt.pack()

def berechne():
    ZielortID=[0,0,0,0,0,0,0,0,0,0,0,0]
    Wochentag=[0,0,0,0,0,0,0]
    now = datetime.now() # aktuelle Zeit
    today = date.today()# aktuelles Datum
    current_time = now.strftime("%H:%M:%S")
    current_date = today.strftime("%d/%m/%Y")
    #Zerlegen von Datum und Zeit in Einzelteile
    Stunde=current_time[0:2]
    Minute=current_time[3:5]
    Jahr=current_date[6:]
    Monat=current_date[3:5]
    Tag=current_date[0:2]
    Wochentag[datetime.today().weekday()]=1 #Wochentag als Integer
    for d in range(12):
        if (variable.get() == OptionList[d]):
            ZielortID[d]=1
    loaded_model = pickle.load(open('model.sav', 'rb'))#Lade den finalen Random Forest 
    x_test=np.array([Jahr,Monat,Tag,Stunde,Minute,Wochentag[0],Wochentag[1],Wochentag[2],Wochentag[3],Wochentag[4],Wochentag[5],Wochentag[6],ZielortID[0],ZielortID[1],ZielortID[2],ZielortID[3],ZielortID[4],ZielortID[5],ZielortID[6],ZielortID[7],ZielortID[8],ZielortID[9],ZielortID[10],ZielortID[11]]).reshape(1,-1)
    result = loaded_model.predict(x_test) # Prüfe wie lange es mit den Parametern dauert
    lsum["text"]='Sie benötigen: '+str(int(result/60))+' Minuten '+str(int(result%60))+' Sekunden' # ergänze die Zeit im Ergebnis-Label
    #print(str(result)[1:3]+' Minuten '+str(result)[3:5]+' Sekunden')
    

button = tk.Button(app, text="Berechnen", command=berechne, font= ('Helvetica', 26))#initialisierung Knopf zum berechnen
button.pack()
lsum = tk.Label(app, text = 'Sie benötigen: ',font = ('Helvetica', 26))#initialisierung Ergebnis-Label
lsum.pack()
app.mainloop()
